//
// Empty 'em actions
//
"use strict";

async function runTasks() {
  let prefs = await getPrefs();
  console.log("Empty 'em: Emptying.. Start");

  //
  // Empty Junk folders before Trash. That way, the Junk messages sent to Trash will be cleaned as well.
  //
  if (prefs.prefs.selectJunkDelete) {
    console.log("Empty 'em: Emptying Junk folders");
    await browser.folder_actions.emptyJunkFolders();
  } else {
    console.log("Empty 'em: Skipping Junk folders by preference");
  }

  //
  // Empty Trash folders
  //
  if (prefs.prefs.selectTrashDelete) {
    console.log("Empty 'em: Emptying Trash folders");
    await browser.folder_actions.emptyTrashFolders();
  } else {
    console.log("Empty 'em: Skipping Trash folders by preference");
  }

  //
  // Once done, send the Done notification
  //
  console.log("Empty 'em: Emptying.. Done");
  if (prefs.prefs.disableDoneNotification) {
    console.log("Empty 'em: Not sending Done notification by preference");
  } else {
    let msg = (prefs.prefs.selectTrashDelete && prefs.prefs.selectJunkDelete) ? "Cleaned Trash and Junk folders" :
              (prefs.prefs.selectJunkDelete) ?  "Cleaned Junk folders" :
              (prefs.prefs.selectTrashDelete) ? "Cleaned Trash folders" :
                                                "Nothing selected to be cleaned";

    browser.notifications.create("emptyem-done-notify", {
      "type": "basic",
      "iconUrl": browser.extension.getURL("icons/icon.png"),
      "title": "Empty 'em done!",
      "message": msg
    });
  }
}

// Browser actions
function emptyEm() {
  runTasks();
}

// Handlers
browser.browserAction.onClicked.addListener(emptyEm);

// vim: ts=2 sw=2 sts=2 et
